<?php
/************************************************
 SLAED CMS 1.2 : Content Management System
 http://www.slaed.ir
 Developed By Mohammad Reza Mahmoudi 
 ~ mrezam2pm@gmail.com
 > Copyright (c) 2005-2010 By Slaed.ir
************************************************/

if (!defined("ADMIN_FILE")) die("Illegal File Access");

function admininfo() {
	global $prefix, $db, $admin_file, $conf, $panel;
	if (is_admin()) {
		$panel = (isset($_GET['panel'])) ? $_GET['panel'] : $panel;
		if ($panel) {
			$w_content = "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\">";
			if (is_active("account") && is_admin_modul("account")) {
				$num = $db->sql_numrows($db->sql_query("SELECT user_id FROM ".$prefix."_users_temp WHERE user_id"));
				$w_content .= "<tr><td><a href=\"".$admin_file.".php?op=user_new#main\">"._NEW_USER."</a>:</td><td>".c2f($num)."</td></tr>";
			}
			if (is_active("files") && is_admin_modul("files")) {
				$num = $db->sql_numrows($db->sql_query("SELECT lid FROM ".$prefix."_files WHERE status='0'"));
				$w_content .= "<tr><td><a href=\"".$admin_file.".php?op=files&status=1#main\">"._NEWFILES."</a>:</td><td>".c2f($num)."</td></tr>";
				$num = $db->sql_numrows($db->sql_query("SELECT lid FROM ".$prefix."_files WHERE status='2'"));
				$w_content .= "<tr><td><a href=\"".$admin_file.".php?op=files&status=2#main\">"._BROCFILES."</a>:</td><td>".c2f($num)."</td></tr>";
			}
			if (is_active("news") && is_admin_modul("news")) {
				$num = $db->sql_numrows($db->sql_query("SELECT sid FROM ".$prefix."_stories WHERE status='0'"));
				$w_content .= "<tr><td><a href=\"".$admin_file.".php?op=news&status=1#main\">"._NEWNEWS."</a>:</td><td>".c2f($num)."</td></tr>";
			}
			$w_content .= "</table>";
			themesidebox(_WAITINGCONT, $w_content, 3);
			if ($conf['sblock'] && is_admin_god()) {
				$phpver = phpversion();
				$osver = php_uname('s');
				$gdver = php_gd();
				$dbver = db_version();
				$phpver = ($phpver >= "4.3.0") ? "<font color=\"green\">$phpver</font>" : "<font color=\"red\">$phpver</font>";
				$gdver = ($gdver >= "2.0") ? "<font color=\"green\">$gdver</font>" : "<font color=\"red\">$gdver</font>";
				$dbverv = ($dbver >= "4.0.0") ? "<font color=\"green\">".cutstr($dbver, 8)."</font>" : "<font color=\"red\">".cutstr($dbver, 8)."</font>";
				$globals = (ini_get('register_globals') == 1) ? "<font color=\"red\">On</font>" : "<font color=\"green\">Off</font>";
				$safe_mode = (ini_get('safe_mode') == 1) ? "<font color=\"green\">On</font>" : "<font color=\"red\">Off</font>";
				$magic_quotes = (ini_get('magic_quotes_gpc') == 1) ? "<font color=\"green\">On</font>" : "<font color=\"red\">Off</font>";
				$p_max = "".files_size(str_replace("M", "", ini_get('post_max_size')) * 1024 * 1024)."";
				$u_max = "".files_size(str_replace("M", "", ini_get('upload_max_filesize')) * 1024 * 1024)."";
				$m_max = "".files_size(str_replace("M", "", ini_get('memory_limit')) * 1024 * 1024)."";
				$mod_rewrite = (function_exists('apache_get_modules')) ? ((array_search("mod_rewrite", apache_get_modules())) ? "<font color=\"green\">On</font>" : "<font color=\"red\">Off</font>") : "<font color=\"red\">Off</font>";
				$s_content = "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\">"
				 
				."<tr><td>OS:</td><td title=\"".$osver."\"><font color=\"blue\">".cutstr($osver, 8)."</font></td></tr>"
				."<tr><td>PHP:</td><td>$phpver</td></tr>"
				."<tr><td>PHP GD:</td><td>$gdver</td></tr>"
				."<tr><td>MySQL:</td><td title=\"".$dbver."\">".$dbverv."</td></tr>"
				."<tr><td>Post size:</td><td><font color=\"blue\">".$p_max."</font></td></tr>"
				."<tr><td>Upload file size:</td><td><font color=\"blue\">".$u_max."</font></td></tr>"
				."<tr><td>Memory limit:</td><td><font color=\"blue\">".$m_max."</font></td></tr>"
				."<tr><td>Execution time:</td><td><font color=\"blue\">".ini_get('max_execution_time')." "._SEC.".</font></td></tr>"
				."<tr><td>Mod Rewrite:</td><td>".$mod_rewrite."</td></tr>"
				."<tr><td>Register globals:</td><td>".$globals."</td></tr>"
				."<tr><td>Safe mode:</td><td>".$safe_mode."</td></tr>"
				."<tr><td>Magic quotes gpc:</td><td>".$magic_quotes."</td></tr>"
				."</table>";
				themesidebox(_SYSTEM_INFO, $s_content, 4);
			}
		}
	}
}

function php_gd() {
	ob_start();
	phpinfo(8);
	$module_info = ob_get_contents();
	ob_end_clean();
	if (preg_match("/\bgd\s+version\b[^\d\n\r]+?([\d\.]+)/i", $module_info, $matches)) {
		$gdversion = $matches[1];
	} else {
		$gdversion = 0;
	}
	return $gdversion;
}

function db_version() {
	global $db;
	list($dbversion) = $db->sql_fetchrow($db->sql_query("SELECT VERSION()"));
	return $dbversion;
}

function end_chmod($dir, $chm) {
	if (file_exists($dir) && intval($chm)) {
		#chmod($dir, "0".$chm."");		 
		$per = substr(decoct(fileperms($dir)), -3);
		if ($per != $chm  & !is_writable($dir)) return $dir." "._ERRORPERM." CHMOD - ".$chm;
		chmod($dir,'0'.$chm);
	}
}

function save_conf($fp, $content, $type="") {
	if (file_exists($fp) && $content) {
		$fp = fopen($fp, "wb");
		$content = (intval($type)) ? "<?php\nif (!defined(\"ADMIN_FILE\")) die(\"Illegal File Access\");\n\n".$content."\n?>" : "<?php\nif (!defined(\"FUNC_FILE\")) die(\"Illegal File Access\");\n\n".$content."\n?>";
		fwrite($fp, $content);
		fclose($fp);
	}
}
?>