<?php
/************************************************
 SLAED CMS 1.2 : Content Management System
 http://www.slaed.ir
 Developed By Mohammad Reza Mahmoudi 
 ~ mrezam2pm@gmail.com
 > Copyright (c) 2005-2010 By Slaed.ir
************************************************/

if (!defined("ADMIN_FILE") || !is_admin_god()) die("Illegal File Access");

function msg_navi() {
	global $admin_file;
	panel();
	open();
	echo "<h1>"._MESSAGESADMIN."</h1>"
	."<h5>[ <a href=\"".$admin_file.".php?op=msg\">"._HOME."</a> | <a href=\"".$admin_file.".php?op=msg_add\">"._ADD."</a> ]</h5>";
	close();
}

function msg() {
	global $prefix, $db, $conf, $admin_file;
	head();
	msg_navi();
	open();
	echo "<table border=\"0\" cellpadding=\"3\" cellspacing=\"1\" class=\"bgcolor4\" width=\"100%\" align=\"center\">"
	."<th>"._ID."</th><th>"._TITLE."</th><th>"._LANGUAGE."</th><th>"._VIEW."</th><th>"._FUNCTIONS."</th></tr>";
	$result = $db->sql_query("SELECT mid, title, content, expire, active, view, mlanguage FROM ".$prefix."_message ORDER BY mid");
	while (list($mid, $title, $content, $expire, $active, $view, $mlanguage) = $db->sql_fetchrow($result)) {
		if (($expire && $expire < time()) || (!$active && $expire)) $db->sql_query("UPDATE ".$prefix."_message SET active='0', expire='0' WHERE mid='$mid'");
		$act = ($active) ? "0" : "1";
		if ($view == 1) { 
			$mview = ""._MVALL.""; 
		} elseif ($view == 2) { 
			$mview = ""._MVANON.""; 
		} elseif ($view == 3) { 
			$mview = ""._MVUSERS.""; 
		} elseif ($view == 4) {
			$mview = ""._MVADMIN.""; 
		}
		$mlanguage = (!$mlanguage) ? ""._ALL."" : $mlanguage;
		echo "<tr class=\"bgcolor1\"><td align=\"center\">".c2f($mid)."</td>"
		."<td align=\"center\">$title</td>"
		."<td align=\"center\">".ucfirst($mlanguage)."</td>"
		."<td align=\"center\">$mview</td>"
		."<td align=\"center\">".ad_edit("".$admin_file.".php?op=msg_add&id=".$mid."")." ".ad_status("".$admin_file.".php?op=msg_status&id=".$mid."&act=".$act."", $active)." ".ad_delete("".$admin_file.".php?op=msg_delete&id=".$mid."", $title)."</td></tr>";
	}
	echo "</table>";
	close();
	foot();
}

function msg_add() {
	global $prefix, $db, $conf, $admin_file, $stop;
	if (isset($_REQUEST['id'])) {
		$mid = intval($_REQUEST['id']);
		list($title, $content, $expire, $active, $view, $mlanguage) = $db->sql_fetchrow($db->sql_query("SELECT title, content, expire, active, view, mlanguage FROM ".$prefix."_message WHERE mid='$mid'"));
	} else {
		$mid = $_POST['mid'];
		$title = save_text($_POST['title']);
		$content = save_text($_POST['content']);
		$expire = ($_POST['newexpire'] == 1 && $_POST['expire']) ? "".time() + ($_POST['expire'] * 86400)."" : $_POST['expire'];
		$active = $_POST['active'];
		$view = $_POST['view'];
		$mlanguage = $_POST['mlanguage'];
	}
	$sel1 = ($view == 1) ? "selected" : "";
	$sel2 = ($view == 2) ? "selected" : "";
	$sel3 = ($view == 3) ? "selected" : "";
	$sel4 = ($view == 4) ? "selected" : "";
	head();
	msg_navi();
	if ($stop) warning($stop, "", "", 1);
	if ($content) preview($title, $content, "", "", "all");
	open();
	echo "<form name=\"post\" action=\"".$admin_file.".php\" method=\"post\">"
	."<div class=\"left\">"._TITLE.":</div><div class=\"center\"><input type=\"text\" name=\"title\" value=\"$title\" maxlength=\"100\" size=\"65\" class=\"admin\"></div>"
	."<div class=\"left\">"._TEXT.":</div><div class=\"center\">".textarea("1", "content", $content, "all", "10")."</div>";
	if ($conf['multilingual'] == 1) echo "<div class=\"left\">"._LANGUAGE.":</div><div class=\"center\"><select name=\"mlanguage\" class=\"admin\">".language($mlanguage)."</select></div>";
	if ($expire != 0) {
		$newexpire = 0;
		$oldexpire = $expire;
		$expire = intval(($expire - time()) / 3600);
		$exp_day = $expire / 24;
		$expire_text = "<input type=\"hidden\" name=\"expire\" value=\"$oldexpire\">"._PURCHASED.": $expire "._HOURS." (".substr($exp_day,0,5)." "._DAYS.")";
	} else {
		$newexpire = 1;
		$expire_text = "<input type=\"text\" name=\"expire\" value=\"0\" maxlength=\"3\" size=\"65\" class=\"admin\">";
	}
	echo "<div class=\"left\">"._EXPIRATION.":</div><div class=\"center\">$expire_text</div>"
	."<div class=\"left\">"._VIEWPRIV."</div><div class=\"center\"><select name=\"view\" class=\"admin\">"
	."<option value=\"1\" $sel1>"._MVALL."</option>"
	."<option value=\"2\" $sel2>"._MVANON."</option>"
	."<option value=\"3\" $sel3>"._MVUSERS."</option>"
	."<option value=\"4\" $sel4>"._MVADMIN."</option>"
	."</select></div>"
	."<div class=\"left\">"._ACTIVATE2."</div><div class=\"center\">".radio_form($active, "active")."</div>"
	."<div class=\"button\"><select name=\"posttype\">"
	."<option value=\"preview\">"._PREVIEW."</option>"
	."<option value=\"save\">"._SEND."</option></select>"
	."<input type=\"hidden\" name=\"newexpire\" value=\"$newexpire\">"
	."<input type=\"hidden\" name=\"mid\" value=\"$mid\">"
	."<input type=\"hidden\" name=\"op\" value=\"msg_save\">"
	." <input type=\"submit\" value=\""._OK."\" class=\"fbutton\"></div></form>";
	close();
	foot();
}

function msg_save() {
	global $prefix, $db, $admin_file, $stop;
	$mid = $_POST['mid'];
	$title = save_text($_POST['title']);
	$content = save_text($_POST['content']);
	$newexpire = $_POST['newexpire'];
	$expire = $_POST['expire'];
	$active = $_POST['active'];
	$view = $_POST['view'];
	$mlanguage = $_POST['mlanguage'];
	$expire = ($newexpire == 1 && $expire) ? "".time() + ($expire * 86400)."" : $expire;
	if (!$title) $stop = ""._CERROR."";
	if (!$content) $stop = ""._CERROR1."";
	if (!$stop && $_POST['posttype'] == "save") {
		if ($mid) {
			$result = $db->sql_query("UPDATE ".$prefix."_message SET title='$title', content='$content', expire='$expire', active='$active', view='$view', mlanguage='$mlanguage' WHERE mid='$mid'");
		} else {
			$result = $db->sql_query("INSERT INTO ".$prefix."_message VALUES (NULL, '$title', '$content', '$expire', '$active', '$view', '$mlanguage')");
		}
		Header("Location: ".$admin_file.".php?op=msg");
	} else {
		msg_add();
	}
}

switch ($op) {
	case "msg":
	msg();
	break;
	
	case "msg_add":
	msg_add();
	break;
	
	case "msg_status":
	$db->sql_query("UPDATE ".$prefix."_message SET active='$act' WHERE mid='$id'");
	Header("Location: ".$admin_file.".php?op=msg");
	break;
	
	case "msg_delete":
	$result = $db->sql_query("DELETE FROM ".$prefix."_message WHERE mid='$id'");
	Header("Location: ".$admin_file.".php?op=msg");
	break;
	
	case "msg_save":
	msg_save();
	break;
}
?>