<?php
/************************************************
 SLAED CMS 1.2 : Content Management System
 http://www.slaed.ir
 Developed By Mohammad Reza Mahmoudi 
 ~ mrezam2pm@gmail.com
 > Copyright (c) 2005-2010 By Slaed.ir
************************************************/

if (!defined("ADMIN_FILE") || !is_admin_modul("content")) die("Illegal File Access");

function content_navi() {
	global $admin_file;
	panel();
	open();
	echo "<h1>"._CONTENT."</h1>"
	."<h5>[ <a href=\"".$admin_file.".php?op=content\">"._HOME."</a> | <a href=\"".$admin_file.".php?op=content_add\">"._ADD."</a> ]</h5>";
	close();
}

function content() {
	global $prefix, $db, $admin_file, $conf;
	head();
	content_navi();
	$num = isset($_GET['num']) ? intval($_GET['num']) : "1";
	$offset = ($num-1) * $conf['anum'];
	$result = $db->sql_query("SELECT id, title, time, counter FROM ".$prefix."_content ORDER BY id DESC LIMIT ".$offset.", ".$conf['anum']."");
	if ($db->sql_numrows($result) > 0) {
		open();
		echo "<table width=\"100%\" border=\"0\" cellpadding=\"3\" cellspacing=\"1\" class=\"sort\" id=\"sort_id\"><tr>"
		."<th>"._ID."</th><th>"._TITLE."</th><th>"._URLRSS."</th><th>"._DATE."</th><th>"._READS."</th><th>"._FUNCTIONS."</th></tr>";
		while (list($id, $title, $time, $counter)= $db->sql_fetchrow($result)) {
			echo "<tr class=\"bgcolor1\">"
			."<td align=\"center\">".c2f($id)."</td>"
			."<td>".$title."</td>"
			."<td align=\"center\"><input type=\"text\" value=\"".$conf['homeurl']."/index.php?name=content&op=view&id=".$id."\" size=\"30
			\"><br /><input type=\"text\" value=\"".$conf['homeurl']."/rss.php?name=content&id=".$id."\" size=\"30\"></td>"
			."<td align=\"center\">".format_time($time,'Y/m/d H:i')."</a></td>"
			."<td align=\"center\">".c2f($counter)."</td>"
			."<td align=\"center\">".ad_view(view_article("content", $id))." ".ad_edit("".$admin_file.".php?op=content_add&id=".$id."")." ".ad_delete("".$admin_file.".php?op=content_delete&id=".$id."", $title)."</td></tr>";
		}
		echo "</table>";
		close();
		list($numstories) = $db->sql_fetchrow($db->sql_query("SELECT Count(id) FROM ".$prefix."_content"));
		$numpages = ceil($numstories / $conf['anum']);
		num_page("", $numstories, $numpages, $conf['anum'], "op=content&");
	} else {
		warning(""._NO_INFO."", "", "", 2);
	}
	foot();
}

function content_add() {
	global $prefix, $db, $admin_file, $stop;
	if (isset($_REQUEST['id'])) {
		$id = intval($_REQUEST['id']);
		$result = $db->sql_query("SELECT id, title, text, field, url, time, refresh FROM ".$prefix."_content WHERE id='$id'");
		list($cid, $title, $text, $field, $url, $time, $refresh) = $db->sql_fetchrow($result);
	} else {
		$cid = $_POST['cid'];
		$title = save_text($_POST['title']);
		$text = save_text($_POST['text']);
		$field = fields_save($_POST['field']);
		$url = $_POST['url'];
		$time = $_POST['time'];
		$refresh = $_POST['refresh'];
	}
	head();
	content_navi();
	if ($stop) warning($stop, "", "", 1);
	$fields = ($field) ? "<br /><br />".fields_out($field, "content")."" : "";
	if ($text) preview($title, $text, "", $field, "content");
	open();
	echo "<form name=\"post\" action=\"".$admin_file.".php\" method=\"post\">"
	."<div class=\"left\">"._TITLE.":</div><div class=\"center\"><input type=\"text\" name=\"title\" value=\"".$title."\" maxlength=\"100\" size=\"65\" class=\"admin\"></div>"
	."<div class=\"left\">"._RSSFILE.":<br /><font class=\"small\">"._RSSINFO."</font></div><div class=\"center\"><input type=\"text\" name=\"url\" value=\"".$url."\" maxlength=\"200\" size=\"65\" class=\"admin\"></div>"
	."<div class=\"left\">"._REFRESHTIME.":<br /><font class=\"small\">"._REFINFO."</font></div><div class=\"center\"><select name=\"refresh\" class=\"admin\">"
	."<option value='1800'";
	if ($refresh == "1800") echo " selected";
	echo ">1/2 "._HOUR."</option>"
	."<option value='3600'";
	if ($refresh == "3600" || !$refresh) echo " selected";
	echo ">1 "._HOUR."</option>"
	."<option value='18000'";
	if ($refresh == "18000") echo " selected";
	echo ">5 "._HOURS."</option>"
	."<option value='36000'";
	if ($refresh == "36000") echo " selected";
	echo ">10 "._HOURS."</option>"
	."<option value='86400'";
	if ($refresh == "86400") echo " selected";
	echo ">24 "._HOURS."</option>"
	."</select></div>"
	."<div class=\"left\">"._ENDTEXT.":</div><div class=\"center\">".textarea("1", "text", $text, "content", "25")."</div>"
	."".fields_in($field, "content").""
	//."<div class=\"left\">"._CHNGSTORY.":</div><div class=\"center\" style=\"white-space: nowrap;\">".datetime(1, $time)."</div>"
	."<div class=\"button\"><select name=\"posttype\">"
	."<option value=\"preview\">"._PREVIEW."</option>"
	."<option value=\"save\">"._SEND."</option></select>"
	."<input type=\"hidden\" name=\"cid\" value=\"$cid\">"
	."<input type=\"hidden\" name=\"op\" value=\"content_save\">"
	." <input type=\"submit\" value=\""._OK."\" class=\"fbutton\"></div></form>";
	close();
	foot();
}

function content_save() {
	global $prefix, $db, $admin_file, $stop;
	$cid = intval($_POST['cid']);
	$title = save_text($_POST['title']);
	$url = $_POST['url'];
	$text = ($url) ? rss_read($url, 1) : save_text($_POST['text']);
	$field = fields_save($_POST['field']);
	$time = save_datetime();
	$refresh = $_POST['refresh'];
	if (!$title) $stop = ""._CERROR."";
	if (!$text && !$url) $stop = ""._CERROR1."";
	if (!$text && $url) $stop = ""._RSSFAIL."";
	if (!$stop && $_POST['posttype'] == "save") {
		if ($cid) {
			$db->sql_query("UPDATE ".$prefix."_content SET title='$title', text='$text', field='$field', url='$url', time='$time', refresh='$refresh' WHERE id='$cid'");
		} else {
			$db->sql_query("INSERT INTO ".$prefix."_content VALUES (NULL, '$title', '$text', '$field', '$url', '$time', '$refresh', '0')");
		}
		Header("Location: ".$admin_file.".php?op=content");
	} else {
		content_add();
	}
}

switch($op) {
	case "content":
	content();
	break;
	
	case "content_add":
	content_add();
	break;
	
	case "content_save":
	content_save();
	break;
	
	case "content_delete":
	$db->sql_query("DELETE FROM ".$prefix."_content WHERE id='".$id."'");
	referer("".$admin_file.".php?op=content");
	break;
}
?>