<?php
/************************************************
 SLAED CMS 1.2 : Content Management System
 http://www.slaed.ir
 Developed By Mohammad Reza Mahmoudi 
 ~ mrezam2pm@gmail.com
 > Copyright (c) 2005-2010 By Slaed.ir
************************************************/

if (!defined("MODULE_FILE")) {
	Header("Location: ../../index.php");
	exit;
}

function content() {
	global $prefix, $db, $admin_file, $conf;
	head();
	title(""._CONTENT."");
	$storynum = 50;
	$num = isset($_GET['num']) ? intval($_GET['num']) : "1";
	$offset = ($num-1) * $storynum;
	$result = $db->sql_query("SELECT id, title, time, counter FROM ".$prefix."_content WHERE time <= now() ORDER BY time DESC LIMIT ".$offset.", ".$storynum."");
	if ($db->sql_numrows($result) > 0) {
		open();
		echo "<table width=\"100%\" border=\"0\" cellpadding=\"3\" cellspacing=\"1\" class=\"sort\" id=\"sort_id\"><tr>"
		."<th>"._ID."</th><th>"._TITLE."</th><th>"._DATE."</th><th>"._READS."</th><th>"._FUNCTIONS."</th></tr>";
		while (list($id, $title, $formatted, $counter)= $db->sql_fetchrow($result)) {
			$time = format_time($formatted,""._DATESTRING."");
			echo "<tr class=\"bgcolor1\">"
			."<td align=\"center\">".c2f($id)."</td>"
			."<td><a href=\"index.php?name=".$conf['name']."&op=view&id=$id\" title=\"$title\">".$title."</a> ".new_graphic($formatted)."</td>"
			."<td align=\"center\">".$time."</a></td>"
			."<td align=\"center\">".c2f($counter)."</td>"
			."<td align=\"center\">".ad_print("index.php?name=".$conf['name']."&op=printe&id=".$id."")."";
			if (is_moder($conf['name'])) echo " ".ad_edit("".$admin_file.".php?op=content_add&id=".$id."")." ".ad_delete("".$admin_file.".php?op=content_delete&id=".$id."", $title)."";
			echo "</td></tr>";
		}
		echo "</table>";
		close();
		list($numstories) = $db->sql_fetchrow($db->sql_query("SELECT Count(id) FROM ".$prefix."_content"));
		$numpages = ceil($numstories / $storynum);
		num_page("", $numstories, $numpages, $storynum, "op=content&");
	} else {
		warning(""._NO_INFO."", "", "", 2);
	}
	foot();
}

function printe() {
	global $prefix, $db, $ThemeSel, $pagetitle, $conf, $confn;
	$id = intval($_GET['id']);
	$result = $db->sql_query("SELECT title, time, text FROM ".$prefix."_content WHERE id='$id' AND time <= now()");
	if ($db->sql_numrows($result) == 1) {
		$db->sql_query("UPDATE ".$prefix."_content SET counter=counter+1 WHERE id='$id'");
		list($ctitle, $date, $text) = $db->sql_fetchrow($result);
		if (file_exists("templates/$ThemeSel/index.php")) {
			require_once("templates/$ThemeSel/index.php");
		} else {
			require_once("function/template.php");
		}
		$conf['defis'] = urldecode($conf['defis']);
		$title = "$ctitle ".$conf['defis']." "._CONTENT." ".$conf['defis']." ".$conf['sitename']."";
		$ptitle = "".format_time($date)." - ".$ctitle."";
		$url = ""._COMESFROM.": <a href=\"".$conf['homeurl']."\" title=\"".$conf['sitename']."\">".$conf['homeurl']."</a><br />"._THEURL.": <a href=\"".$conf['homeurl']."/index.php?name=".$conf['name']."&op=view&id=$id\" title=\"".$title."\">".$conf['homeurl']."/index.php?name=".$conf['name']."&op=view&id=$id</a>";
		prints($title, $ptitle, bb_decode($text, $conf['name']), $url);
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

function view() {
	global $db, $prefix, $pagetitle, $conf, $confn, $admin_file, $hometext;
	$id = intval($_GET['id']);
	$pag = intval($_GET['pag']);
	$word = ($_GET['word']) ? text_filter($_GET['word']) : "";
	$result = $db->sql_query("SELECT id, title, text, field, url, UNIX_TIMESTAMP(time) as formatted, refresh FROM ".$prefix."_content WHERE id = '$id' AND time <= now()");
	if ($db->sql_numrows($result) == 1) {
		$db->sql_query("UPDATE ".$prefix."_content SET counter=counter+1 WHERE id='$id'");
		list($id, $title, $text, $field, $url, $otime, $refresh) = $db->sql_fetchrow($result);
		if ($url) {
			$past = time() - $refresh;
			if ($otime < $past) {
				$content = rss_read($url, 1);
				$time = save_datetime();
				$db->sql_query("UPDATE ".$prefix."_content SET text='$content', time='$time' WHERE id='$id'");
			}
		}
		$pagetitle = "".$conf['defis']." "._CONTENT." ".$conf['defis']." $title";
		$fields = fields_out($field, $conf['name']);
		$fields = ($fields) ? "<br /><br />".$fields."" : "";
		$hometext = "".$text."".$fields."";
		head();
		title("".$title."");
		open();
		echo search_color(bb_decode($hometext, $conf['name']), $word);
		close();
		foot();
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

switch($op) {
	default:
	content();
	break;

	case "printe":
	printe();
	break;

	case "view":
	view();
	break;
}
?>