<?php
/************************************************
 SLAED CMS 1.2 : Content Management System
 http://www.slaed.ir
 Developed By Mohammad Reza Mahmoudi 
 ~ mrezam2pm@gmail.com
 > Copyright (c) 2005-2010 By Slaed.ir
************************************************/

if (!defined("ADMIN_FILE") || !is_admin_modul("voting")) die("Illegal File Access");

function voting_navi() {
	global $admin_file;
	panel();
	open();
	echo "<h1>"._VOTING."</h1>"
	."<h5>[ <a href=\"".$admin_file.".php?op=voting\">"._HOME."</a>"
	." | <a href=\"".$admin_file.".php?op=voting_add\">"._ADD."</a>"
	." | <a href=\"".$admin_file.".php?op=voting_conf\">"._PREFERENCES."</a> ]</h5>";
	close();
}

function voting() {
	global $prefix, $db, $admin_file, $conf;
	head();
	voting_navi();
	$num = isset($_GET['num']) ? intval($_GET['num']) : "1";
	$offset = ($num-1) * $conf['anum'];
	$offset = intval($offset);
	$result = $db->sql_query("SELECT poll_id, poll_date, poll_title, planguage FROM ".$prefix."_survey ORDER BY poll_id DESC LIMIT ".$offset.", ".$conf['anum']."");
	if ($db->sql_numrows($result) > 0) {
		open();
		echo "<table width=\"100%\" border=\"0\" cellpadding=\"3\" cellspacing=\"1\" class=\"sort\" id=\"sort_id\"><tr><th>"._ID."</th><th>"._TITLE."</th>";
		if ($conf['multilingual'] == 1)  echo "<th>"._LANGUAGE."</th>";
		echo "<th>"._DATE."</th><th>"._FUNCTIONS."</th></tr>";
		while (list($poll_id, $poll_date, $poll_title, $planguage) = $db->sql_fetchrow($result)) {
			echo "<tr class=\"bgcolor1\"><td align=\"center\">".c2f($poll_id)."</td>"
			."<td>".$poll_title."</td>";
			if ($conf['multilingual'] == 1) {
				$planguage = (!$planguage) ? ""._ALL."" : $planguage;
				echo "<td align=\"center\">".ucfirst($planguage)."</td>";
			}
			echo "<td align=\"center\">".format_time($poll_date,'Y/m/d H:i')."</td>"
			."<td align=\"center\">".ad_edit("".$admin_file.".php?op=voting_add&id=".$poll_id."")." ".ad_delete("".$admin_file.".php?op=voting_delete&id=".$poll_id."", $poll_title)."</td></tr>";
		}
		echo "</table>";
		close();
		list($numstories) = $db->sql_fetchrow($db->sql_query("SELECT Count(poll_id) FROM ".$prefix."_survey"));
		$numpages = ceil($numstories / $conf['anum']);
		num_page("", $numstories, $numpages, $conf['anum'], "op=voting&");
	}
	foot();
}

function voting_add() {
	global $prefix, $db, $admin_file, $conf;
	if (isset($_REQUEST['id'])) {
		$pid = intval($_REQUEST['id']);
		$result = $db->sql_query("SELECT poll_id, poll_date, poll_title, poll_questions, planguage, acomm FROM ".$prefix."_survey WHERE poll_id='$pid'");
		list($poll_id, $poll_date, $poll_title, $poll_questions, $planguage, $acomm) = $db->sql_fetchrow($result);
	}
	head();
	voting_navi();
	open();
	echo "<form action=\"".$admin_file.".php\" method=\"post\">"
	."<div class=\"left\">"._POLLTITLE.":</div><div class=\"center\"><input type=\"text\" name=\"polltitle\" value=\"$poll_title\" size=\"65\" class=\"admin\"></div>";
	$questions = explode("|", $poll_questions);
	for ($i = 1; $i <= 12; $i++) {
		$p = $i - 1;
		echo "<div class=\"left\">"._POLLEACH. c2f($i)." : </div><div class=\"center\"><input type=\"text\" name=\"optiontext[]\" value=\"$questions[$p]\" size=\"65\" class=\"admin\"></div>";
	}
	if ($conf['multilingual'] == 1) echo "<div class=\"left\">"._LANGUAGE.":</div><div class=\"center\"><select name=\"language\" class=\"admin\">".language($planguage)."</select></div>";
	//echo "<div class=\"left\">"._CHNGSTORY.":</div><div class=\"center\">".datetime(1, $poll_date)."</div>"
	echo "<div class=\"left\">"._C_16."</div><div class=\"center\">".radio_form($acomm, "acomm", 1)."</div>"
	."<div class=\"button\"><input type=\"hidden\" name=\"poll_id\" value=\"$poll_id\"><input type=\"hidden\" name=\"op\" value=\"voting_save\"><input type=\"submit\" value=\""._SAVE."\" class=\"fbutton\"></div></form>";
	close();
	foot();
}

function voting_save() {
	global $prefix, $db, $admin_file;
	$poll_id = intval($_POST['poll_id']);
	$polltitle = $_POST['polltitle'];
	$language = $_POST['language'];
	$acomm = $_POST['acomm'];
	$optiontext = $_POST['optiontext'];
	$poll_date = save_datetime();
	$number_optiontext = count($optiontext);
	$op_text = "";
	for ($p = 0; $p < $number_optiontext; $p++) {
		if ($optiontext[$p] != "") $op_text .= "$optiontext[$p]|";
	}
	if ($poll_id) {
		$db->sql_query("UPDATE ".$prefix."_survey SET poll_date='$poll_date', poll_title='$polltitle', poll_questions='$op_text', planguage='$language', acomm='$acomm' WHERE poll_id='$poll_id'");
	} else {
		$db->sql_query("INSERT INTO ".$prefix."_survey (poll_id, poll_date, poll_title, poll_questions, planguage, acomm) VALUES (NULL, '$poll_date', '$polltitle', '$op_text', '$language', '$acomm')");
	}
	Header("Location: ".$admin_file.".php?op=voting");
}

function voting_conf() {
	global $admin_file;
	head();
	voting_navi();
	include("config/config_voting.php");
	$permtest = end_chmod("config/config_voting.php", 666);
	if ($permtest) warning($permtest, "", "", 1);
	open();
	echo "<h2>"._GENSITEINFO."</h2>"
	."<form action='".$admin_file.".php' method='post'>"
	."<div class=\"left\">"._VOTING_TIME.":</div><div class=\"center\"><input type='text' name='voting_t' value='".intval($confv['voting_t'] / 86400)."' size='65' class=\"admin\"></div>"
	."<div class=\"left\">"._VOTING_NUM.":</div><div class=\"center\"><input type='text' name='pollnum' value='".$confv['pollnum']."' size='65' class=\"admin\"></div>"
	."<div class=\"button\"><input type='hidden' name='op' value='voting_conf_save'><input type='submit' value='"._SAVECHANGES."' class=\"fbutton\"></div></form>";
	close();
	foot();
}

function voting_conf_save() {
	global $admin_file;
	$xvoting_t = (!$_POST['voting_t']) ? 86400 : intval($_POST['voting_t'] * 86400);
	$xpollnum = (!intval($_POST['pollnum'])) ? 10 : $_POST['pollnum'];
	$content = "\$confv = array();\n"
	."\$confv['voting_t'] = \"".$xvoting_t."\";\n"
	."\$confv['pollnum'] = \"".$xpollnum."\";\n";
	save_conf("config/config_voting.php", $content);
	Header("Location: ".$admin_file.".php?op=voting_conf");
}

switch($op) {
	case "voting":
	voting();
	break;
	
	case "voting_add":
	voting_add();
	break;
	
	case "voting_save":
	voting_save();
	break;
	
	case "voting_delete":
	$db->sql_query("DELETE FROM ".$prefix."_survey WHERE poll_id='".$id."'");
	$db->sql_query("DELETE FROM ".$prefix."_comment WHERE cid='".$id."' AND modul='voting'");
	Header("Location: ".$admin_file.".php?op=voting");
	break;
	
	case "voting_conf":
	voting_conf();
	break;
	
	case "voting_conf_save":
	voting_conf_save();
	break;
}
?>