<?php
/************************************************
 SLAED CMS 1.2 : Content Management System
 http://www.slaed.ir
 Developed By Mohammad Reza Mahmoudi 
 ~ mrezam2pm@gmail.com
 > Copyright (c) 2005-2010 By Slaed.ir
************************************************/

define("MODULE_FILE", true);
include("function/function.php");
include("config/config_rss.php");
get_lang();
Header("Content-Type: application/rss+xml");
Header("Content-Encoding: none");

$name = (isset($_POST['name'])) ? analyze($_POST['name']) : analyze($_GET['name']);
$name = ($name) ? $name : $conf['module'];
$cat = (isset($_POST['cat'])) ? intval($_POST['cat']) : intval($_GET['cat']);
$num = (isset($_POST['num'])) ? intval($_POST['num']) : intval($_GET['num']);
$num = ($num) ? (($num <= $confrs['max']) ? $num : $confrs['max']) : $confrs['min'];
$id = (isset($_POST['id'])) ? intval($_POST['id']) : intval($_GET['id']);

if (($name == "content")) {
	// && $id $result = $db->sql_query("SELECT id, title, text, time FROM ".$prefix."_content WHERE id='$id' AND time<=now()");
	 $result = $db->sql_query("SELECT id, title, text, time FROM ".$prefix."_content WHERE  time<=now()");
} elseif ($name == "news") {
	$where = ($cat) ? "WHERE catid='$cat' AND time<=now() AND status!='0'" : "WHERE time<=now() AND status!='0'";
	$result = $db->sql_query("SELECT s.sid, s.name, s.title, s.time, s.hometext, c.title, u.user_name FROM ".$prefix."_stories AS s LEFT JOIN ".$prefix."_categories AS c ON (s.catid=c.id) LEFT JOIN ".$prefix."_users AS u ON (s.uid=u.user_id) ".$where." ORDER BY time DESC LIMIT ".$num."");
	$name = "news";
} else {
	$result = "";
	$name = "";
}

$content = "<?xml version=\"1.0\" encoding=\""._CHARSET."\"?>\n"
."<rss version=\"2.0\">\n"
."<channel>\n"
."<title>".htmlspecialchars($conf['sitename'])."</title>\n"
."<link>".$conf['homeurl']."</link>\n"
."<description>".htmlspecialchars($conf['slogan'])."</description>\n"
."<generator>Open SLAED ".$conf['version']."</generator>\n"
."<copyright>Copyright (c) Open SLAED ".$conf['version']."</copyright>\n"
."<language>".htmlspecialchars(substr(""._LOCALE."", 0, 2))."</language>\n"
."<lastBuildDate>".date("D, j M Y H:m:s O")."</lastBuildDate>\n\n";
if ($name && $name != "content" && $result) {
	while (list($rid, $uname, $rtitle, $rtime, $rhometext, $rctitle, $user_name) = $db->sql_fetchrow($result)) {
		$rauthor = ($user_name) ? $user_name : (($uname) ? $uname : $confu['anonym']);
		$content .= "<item>\n"
		."<title>".htmlspecialchars($rtitle)."</title>\n"
		."<pubDate>".htmlspecialchars(date("D, j M Y H:m:s O", strtotime($rtime)))."</pubDate>\n"
		."<guid>".$conf['homeurl']."/index.php?name=".$name."&amp;op=view&amp;id=$rid</guid>\n"
		."<description>".htmlspecialchars(bb_decode($rhometext, $name))."</description>\n"
		."<comments>".$conf['homeurl']."/index.php?name=".$name."&amp;op=view&amp;id=$rid#$rid</comments>\n";
		$content .= ($rctitle) ? "<category>".htmlspecialchars($rctitle)."</category>\n" : "";
		$content .= "<author>antispam@antispam.com (".htmlspecialchars($rauthor).")</author>\n"
		."</item>\n\n";
	}
} elseif ($name && $name == "content" && $result) {
	list($rid, $rtitle, $rhometext, $rtime) = $db->sql_fetchrow($result);
	$content .= "<item>\n"
	."<title>".htmlspecialchars($rtitle)."</title>\n"
	."<pubDate>".htmlspecialchars(date("D, j M Y H:m:s O", strtotime($rtime)))."</pubDate>\n"
	."<guid>".$conf['homeurl']."/index.php?name=".$name."&amp;op=view&amp;id=$rid</guid>\n"
	."<description>".htmlspecialchars(bb_decode($rhometext, $name))."</description>\n"
	."</item>\n\n";
}
$content .= "</channel>\n</rss>";
echo $content;
?>