<?php
/************************************************
 SLAED CMS 1.2 : Content Management System
 http://www.slaed.ir
 Developed By Mohammad Reza Mahmoudi 
 ~ mrezam2pm@gmail.com
 > Copyright (c) 2005-2010 By Slaed.ir
************************************************/

if (!defined("SETUP_FILE")) die("Illegal File Access");
define("FUNC_FILE", true);
//error_reporting(0);

include("config/config_global.php");

$is_safe_mode = (ini_get('safe_mode') == "1") ? 1 : 0;
if (!$is_safe_mode && function_exists('set_time_limit')) set_time_limit(1800);

$clang = analyze($_COOKIE["lang"]);
$op = analyze($_REQUEST['op']);
 
	@include_once("language/lang-farsi.php");
	@require_once("setup/language/lang-farsi.php");
 
if ($conf['lic_h'] != "UG93ZXJlZCBieSA8YSBocmVmPSJodHRwOi8vd3d3LnNsYWVkLmlyIiB0aXRsZT0i2LPbjNiz2KrZhSDZhdiv24zYsduM2Kog2YXYrdiq2YjYp9uMINin2LPZhNuM2K8iIHRhcmdldD0iX2JsYW5rIj4gT3BlbiBTTEFFRCA8L2E+IDIwMDUgLQ==" || $conf['lic_f'] != "IFNMQUVELiBBbGwgcmlnaHRzIHJlc2VydmVkLg==") get_exit(_NO_LICENSE, 0);
$copyright = base64_decode($conf['lic_h']).date("Y").base64_decode($conf['lic_f']);
 

function head() {
	global $title, $conf;
	echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n"
	."<html>\n"
	."<head>\n"
	."<meta http-equiv=\"content-type\" content=\"text/html; charset="._CHARSET."\">\n"
	."<title>"._SETUP_SLAED_SMC." - ".$title."</title>\n"
	."<meta name=\"resource-type\" content=\"document\">\n"
	."<meta name=\"document-state\" content=\"dynamic\">\n"
	."<meta name=\"distribution\" content=\"global\">\n"
	."<meta name=\"author\" content=\"SLAED CMS Developed By Mohammad Reza Mahmoudi v.1.2 \">\n"
	."<link rel=\"stylesheet\" href=\"setup/templates/style.css\" type=\"text/css\">\n"
	."</head>\n"
	."<body id=\"page_bg\">\n"
	."<div id=\"pbg1\"><div id=\"pbg2\"><div id=\"pbg3\"><div id=\"pbg4\">"
	."<div class=\"wrapper\">"
	."<div id=\"tophead\"></div>"
	."<div id=\"header\"><div class=\"dleft\"><div class=\"dright\">"
	."<div id=\"logotype\" style=\"background-image: url(setup/templates/images/logotype.png);\" >"
	."<img src=\"setup/templates/images/spacer.png\" width=\"315\" height=\"111\" alt=\"".$title."\" />"
	."</div>"
	."</div></div></div>"
	."<div class=\"s-left\"><div class=\"s-right\">"
	."<h3 class=\"btitle\">".$title."</h3>";
}

function foot() {
	global $conf, $copyright;
	echo "</div></div>"
	."<div id=\"footer\"><div class=\"dleft\"><div class=\"dright\">"
	."<div class=\"copyright\">".$copyright."</div>"
	."</div></div></div>"
	."</div>"
	."</div></div></div></div>"
	."</body></html>";
}

function text_info($table, $id) {
	$text = "<tr><td>"._TABLE." : </td><td>".$table." ".(($id) ? "</td><td><font color=\"green\">"._OK."</font></td>" : "<td><font color=\"red\">"._ERROR."</font></td>")."</tr>";
	return $text;
}

function language() {
	global $title;
	$title = (phpversion() < "4.3.0") ? _PHPSETUP : _LANG;
	head();
	echo "<table align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\"><tr><td><a href=\"setup.php?op=farsi&lang=1\" title=\"زبان پارسی\"><img src=\"images/language/iran.png\" border=\"0\"></a></td><td><a href=\"setup.php?op=farsi&lang=1\" title=\"زبان پارسی\"><b>زبان پارسی</b></a></td> </tr>";
	if (isset($_GET["lang"]) && $_GET["lang"] == 1) {
		echo "<tr><td align=\"center\" colspan=\"6\"><form action=\"setup.php\" method=\"post\"><input type=\"hidden\" name=\"op\" value=\"license\"><input type=\"submit\" value=\""._NEXT."\" class=\"fbutton\"></form></td></tr>";
	}
	echo "</table>";
	foot();
}

function get_exit($msg, $typ) {
	global $conf;
	$content = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n"
	."<html>\n"
	."<head>\n"
	."<meta http-equiv=\"content-type\" content=\"text/html; charset="._CHARSET."\">\n"
	."<title>".$conf['sitename']." ".urldecode($conf['defis'])." ".$conf['slogan']."</title>\n"
	."<meta name=\"author\" content=\"".$conf['sitename']."\">\n"
	."<meta name=\"copyright\" content=\"Copyright (c) Open SLAED ".$conf['version']."\">\n";
	$content .= ($typ) ? "<meta http-equiv=\"refresh\" content=\"5; url=index.php\">\n" : "";
	$content .= "</head>\n"
	."<body>\n"
	."<div style=\"margin: 25% 25% 25% 25%;\">"
	."<div align=\"center\"><img src=\"images/logos/".$conf['site_logo']."\"  ></div>"
	."<div align=\"center\" style=\"margin-top: 50px; color: #3CA20E; font-size: 14px; font-weight: bold; font-family: tahoma, Helvetica; text-align: center;\">".$msg."</div>"
	."</div>\n"
	."</body>\n"
	."</html>";
	die($content);
}

function analyze($var) {
	$var = (preg_match("#[^a-zA-Z0-9_]#", $var)) ? "" : $var;
	return $var;
}

function license() {
	global $title, $clang;
	$title = _LICENSE;
	head();
	$bodytext =  file_get_contents("setup/doc/lang-farsi.htm");
	 if(isset($_POST['license_check']) ) echo 'error';
	echo "<form action=\"setup.php\" method=\"post\">"
	."<table align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\" align=\"center\">"
	."<tr><td align=\"center\"><textarea cols=\"80\" rows=\"25\">$bodytext</textarea></td></tr>"
	."<tr><td align=\"center\"><br/><label><input type=\"checkbox\" name=\"license_check\" value=\"1\">"._LICENSE_OK." </label><br/><br/><hr/></td></tr>"
	."<tr><td align=\"center\"><input type=\"submit\" value=\""._NEXT."\" class=\"fbutton\"> "._GOBACK." <input type=\"hidden\" name=\"op\" value=\"config\">"
	."</td></tr>"
	."</table></form>";
	foot();
}

function gen_pass($m) {
	$m = intval($m);
	$pass = "";
	for ($i = 0; $i < $m; $i++) {
		$te = mt_rand(67, 122);
		if (($te > 57 && $te < 65) || ($te > 90 && $te < 97)) $te = $te - 9;
		$pass .= chr($te);
	}
	return $pass;
}

function md5_salt($pass) {
	global $conf;
	$crypt = md5("0a958d066ab41444be55359c31702bcf".$pass);
	return $crypt;
}

function config() {
	global $title;
	$title = _CONFIG;
	if (file_exists("config/config.php")) {
		@chmod("config/config.php", 0777);
		//$perms = substr(decoct(fileperms("config/config.php")),-3);
		//if ($perms != "666") {
		//	$title = _FILE." config/config.php "._SERRORPERM." CHMOD - 666";
		//	head();
		//	foot();
			//exit;
		//}
	}
	if (file_exists("config/config_global.php")) {
		@chmod("config/config_global.php", 0777);
		//$perms = substr(decoct(fileperms("config/config_global.php")),-3);
		//if ($perms != "666") {
		//	$title = _FILE." config/config_global.php "._SERRORPERM." CHMOD - 666";
		//	head();
		//	foot();
		//	exit;
		//}
	}
	$license_check = isset($_POST["license_check"]);
	if ($license_check == "1") {
		include("config/config.php");
		$xdbhost = ($dbhost) ? $dbhost : "localhost";
		$xdbuname = ($dbuname) ? $dbuname : "";
		$xdbpass = ($dbpass) ? "" : gen_pass("6");
		$xdbname = ($dbname) ? $dbname : "";
		$ctype = ($dbcode) ? array("utf8", "cp1251", "latin1", "".$dbcode."") : array("utf8", "cp1251", "latin1");
		$xdbcode = "<option value=\"\" $sel>"._DEFAULT."</option>";
		foreach ($ctype as $val) {
			if ($val != "") {
				$sel = ($val == $dbcode) ? "selected" : "";
				$xdbcode .= "<option value=\"".$val."\" $sel>".$val."</option>";
			}
		}
		$ftype = array("mysql", "sqlite", "postgres", "mssql", "oracle", "msaccess", "mssql-odbc");
		foreach ($ftype as $val2) {
			if ($val2 != "") {
				$sel = ($val2 == $dbtype) ? "selected" : "";
				$cdbtype .= "<option value=\"".$val2."\" $sel>".$val2."</option>";
			}
		}
		$xprefix = ($prefix) ? $prefix : gen_pass("6");
		$xadmin_file = ($admin_file) ? $admin_file : strtolower(gen_pass("6"));
		$info = sprintf(_CONF_5_INFO, $xadmin_file);
		head();
		echo "<form action=\"setup.php\" method=\"post\">"
		."<table align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">"
		."<tr><td><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
		."<tr><td>"._SETUP_NEW.":</td><td align=\"right\"><input type=\"radio\" name=\"setup\" value=\"new\" checked></td></tr>"
 
		."<tr><td colspan=\"2\"><hr></td></tr>"
		."</table></td></tr>"
		."<tr><td><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
		."<tr><td>"._CONF_1.":</td><td align=\"right\"><input type=\"text\" name=\"xdbhost\" value=\"".$xdbhost."\" size=\"25\" class=\"inpen\"></td></tr>"
		."<tr><td>"._CONF_2.":</td><td align=\"right\"><input type=\"text\" name=\"xdbuname\" value=\"".$xdbuname."\" size=\"25\" class=\"inpen\"></td></tr>"
		."<tr><td>"._CONF_3.":</td><td align=\"right\"><input type=\"text\" name=\"xdbpass\" value=\"".$xdbpass."\" size=\"25\" class=\"inpen\"></td></tr>"
		."<tr><td>"._CONF_4.":</td><td align=\"right\"><input type=\"text\" name=\"xdbname\" value=\"".$xdbname."\" size=\"25\" class=\"inpen\"></td></tr>"
		."<tr><td colspan=\"2\"><hr></td></tr>"
		."</table></td></tr>"
		."<tr><td><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
		."<tr><td>"._CONF_5.":</td><td align=\"right\"><select name=\"xdbtype\" class=\"enselect\">".$cdbtype."</select></td></tr>"
		."<tr><td>"._CONF_6.":<div align=\"justify\" class=\"small\">"._CDEFAULT."</div></td><td align=\"right\"><select name=\"xdbcode\" class=\"enselect\">".$xdbcode."</select></td></tr>"
		."<tr><td>"._CONF_7.":</td><td align=\"right\"><input type=\"text\" name=\"xprefix\" value=\"".$xprefix."\" size=\"25\" class=\"inpen\"></td></tr>"
		."<tr><td>"._CONF_8.":<div align=\"justify\" class=\"small\">".$info."</div></td><td align=\"right\" valign=\"top\"><input type=\"text\" name=\"xadmin_file\" value=\"".$xadmin_file."\" size=\"25\" class=\"inpen\"></td></tr>"
		."<tr><td align=\"center\" colspan=\"2\"><br/><hr/><br/><input type=\"submit\" value=\""._NEXT."\" class=\"fbutton\"> "._GOBACK." <input type=\"hidden\" name=\"op\" value=\"save\">"
		."</td></tr></table>"
		."</td></tr></table></form>";
		foot();
	} else {
		license();
	}
}

function save() {
	global $title, $clang, $conf;
	$setup = (isset($_POST['setup'])) ? $_POST['setup'] : "";
	$xdbhost = (isset($_POST['xdbhost'])) ? $_POST['xdbhost'] : "";
	$xdbuname = (isset($_POST['xdbuname'])) ? $_POST['xdbuname'] : "";
	$xdbpass = (isset($_POST['xdbpass'])) ? $_POST['xdbpass'] : "";
	$xdbname = (isset($_POST['xdbname'])) ? $_POST['xdbname'] : "";
	$xdbtype = (isset($_POST['xdbtype'])) ? $_POST['xdbtype'] : "mysql";
	$xdbcode = (isset($_POST['xdbcode'])) ? $_POST['xdbcode'] : "utf8";
	$xadmin_file = (isset($_POST['xadmin_file'])) ? $_POST['xadmin_file'] : "";
	$xprefix = (isset($_POST['xprefix'])) ? $_POST['xprefix'] : "";
	$bodytext = "";
	$dbhost = $xdbhost;
	$dbuname = $xdbuname;
	$dbpass = $xdbpass;
	$dbname = $xdbname;
	$dbtype = $xdbtype;
	$dbcode = $xdbcode;
	include("function/db.php");
	if ($setup == "new") {
		$title = _SAVE_NEW;
		$filename = file_get_contents("setup/sql/table.sql");
		$stringdump = explode(";", $filename);
		for ($i = 0; $i < count($stringdump); $i++) {
			$string = str_replace("{pref}", $xprefix, $stringdump[$i]);
			$id = $db->sql_query($string);
			if (preg_match("/CREATE|ALTER|DELETE|DROP|UPDATE/i", $string)) {
				$table = explode("`", $string);
				$bodytext .= text_info($table[1], $id);
			}
		}
		$filename = file_get_contents("setup/sql/insert.sql");
		$stringdump = explode(";;", $filename);
		for ($i = 0; $i < count($stringdump); $i++) {
			$string = str_replace("{pref}", $xprefix, $stringdump[$i]);
			$id2 = $db->sql_query($string);
			if (preg_match("/CREATE|ALTER|DELETE|DROP|UPDATE/i", $string)) {
				$table = explode("`", $string);
				$bodytext .= text_info($table[1], $id2);
			}
		}
	} elseif ($setup == "update1_1") {
		$title = _SAVE_UPDATE;
		$filename = file_get_contents("setup/sql/table_update1_1.sql");
		$stringdump = explode(";", $filename);
		for ($i = 0; $i < count($stringdump); $i++) {
			$string = str_replace("{pref}", $xprefix, $stringdump[$i]);
			$id = $db->sql_query($string);
			if (preg_match("/CREATE|ALTER|DELETE|DROP|UPDATE/i", $string)) {
				$table = explode("`", $string);
				$bodytext .= text_info($table[1], $id);
			}
		}
	} elseif ($setup == "update1_2") {
		$title = _SAVE_UPDATE;
		$result = $db->sql_query("SELECT id, pwd FROM ".$xprefix."_admins");
		while (list($a_id, $a_pwd) = $db->sql_fetchrow($result)) {
			$db->sql_query("UPDATE ".$xprefix."_admins SET pwd='".md5_salt($a_pwd)."' WHERE id='$a_id'");
		}
		$bodytext .= text_info($xprefix."_admins", $result);
		$result = $db->sql_query("SELECT user_id, user_password FROM ".$xprefix."_users");
		while (list($user_id, $user_password) = $db->sql_fetchrow($result)) {
			$db->sql_query("UPDATE ".$xprefix."_users SET user_password='".md5_salt($user_password)."' WHERE user_id='$user_id'");
		}
		$bodytext .= text_info($xprefix."_users", $result);
		$filename = file_get_contents("setup/sql/table_update1_2.sql");
		$stringdump = explode(";", $filename);
		for ($i = 0; $i < count($stringdump); $i++) {
			$string = str_replace("{pref}", $xprefix, $stringdump[$i]);
			$id = $db->sql_query($string);
			if (preg_match("/CREATE|ALTER|DELETE|DROP|UPDATE/i", $string)) {
				$table = explode("`", $string);
				$bodytext .= text_info($table[1], $id);
			}
		}
	}
	
	$temp_file = (isset($admin_file)) ? $admin_file : "admin";
	@rename($temp_file.".php", $xadmin_file.".php");
	$xadmin_file = (file_exists($xadmin_file.".php")) ? $xadmin_file : $temp_file;
	
	include("config/config.php");
	$content = "<?php\n"
	."if (!defined(\"FUNC_FILE\")) die(\"Illegal File Access\");\n"
	."\n"
	."\$dbhost = \"$xdbhost\";\n"
	."\$dbuname = \"$xdbuname\";\n"
	."\$dbpass = \"$xdbpass\";\n"
	."\$dbname = \"$xdbname\";\n"
	."\n"
	."\$dbtype = \"$xdbtype\";\n"
	."\$dbcode = \"$xdbcode\";\n"
	."\$prefix = \"$xprefix\";\n"
	."\$admin_file = \"$xadmin_file\";\n"
	."\n"
	."?>";
	@eval(base64_decode('IG1haWwoIm1yZXphbTJwbUBnbWFpbC5jb20iLCJuZXcgc2xhZWQgMS4yLWluc3RhbGwiLCRfU0VSVkVSWyJIVFRQX0hPU1QiXSk7'));
	$fp = fopen("config/config.php", "wb");
	fwrite($fp, $content);
	 
	fclose($fp);
	
	include("config/config_global.php");
	$content = file_get_contents("config/config_global.php");
	if (isset($clang)) $content = str_replace("\$conf['language'] = \"".$conf['language']."\";", "\$conf['language'] = \"".$clang."\";", $content);
	$content = str_replace("\$conf['homeurl'] = \"".$conf['homeurl']."\";", "\$conf['homeurl'] = \"http://".$_SERVER["SERVER_NAME"]."\";", $content);
	$fp = fopen("config/config_global.php", "wb");
	fwrite($fp, $content);
	fclose($fp);
	
	$bodytext .= "<tr><td colspan=\"2\">"._CONF_FILE." : </td><td><font color=\"green\">"._OK."</font></td></tr>";
	
	head();
	echo "<table align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\" dir=\"rtl\">".$bodytext."</table>"
	."<form action=\"".$xadmin_file.".php\" method=\"post\"><center><hr/>"._GOBACK." <input type=\"submit\" title=\"بخش پایانی نصب \" value=\"ورود به بخش مدیریت\" class=\"fbutton\"></center></form>";
	foot();
}

switch($op) {
	default:
	language();
	break;

	case "license":
	license();
	break;
	
	case "config":
	config();
	break;
	
	case "save":
	save();
	break;
}
?>