<?php
/************************************************
 SLAED CMS 1.2 : Content Management System
 http://www.slaed.ir
 Developed By Mohammad Reza Mahmoudi 
 ~ mrezam2pm@gmail.com
 > Copyright (c) 2005-2010 By Slaed.ir
************************************************/

if (!defined("ADMIN_FILE") || !is_admin_god()) die("Illegal File Access");

function groups_navi() {
	global $admin_file;
	panel();
	open();
	echo "<h1>"._GROUPSADMIN."</h1>"
	."<h5>[ <a href=\"".$admin_file.".php?op=groups\">"._HOME."</a> | <a href=\"".$admin_file.".php?op=groups_add\">"._ADD."</a> | <a href=\"".$admin_file.".php?op=groups_points\">"._POINTS."</a> ]</h5>";
	close();
}

function groups() {
	global $prefix, $db, $admin_file;
	head();
	groups_navi();
	$result = $db->sql_query("SELECT id, name, description, points, extra, rank FROM ".$prefix."_groups ORDER BY id");
	if ($db->sql_numrows($result) > 0) {
		open();
		echo "<table width=\"100%\" border=\"0\" cellpadding=\"3\" cellspacing=\"1\" class=\"sort\" id=\"sort_id\">"
		."<tr><th>"._ID."</th><th>"._RANK."</th><th>"._GROUP."</th><th>"._POINTS."</th><th>"._USERSCOUNT."</th><th>"._SPEC."</th><th>"._FUNCTIONS."</th></tr>";
		while (list($grid, $grname, $description, $points, $extra, $rank) = $db->sql_fetchrow($result)) {
			if (intval($extra)) {
				$extra = ""._YES."";
				list($users_num) = $db->sql_fetchrow($db->sql_query("SELECT Count(*) FROM ".$prefix."_users WHERE user_group='".$grid."'"));
				$users_num = "<a href=\"".$admin_file.".php?op=user_show&search=6&chng_user=".$grid."\" title=\""._READMORE."\">".$users_num."</a>";
			} else {
				$extra = ""._NO."";
				list($users_num) = $db->sql_fetchrow($db->sql_query("SELECT Count(*) FROM ".$prefix."_users WHERE user_points>='".$points."'"));
				$users_num = "<a href=\"".$admin_file.".php?op=user_show&search=7&chng_user=".$points."\" title=\""._READMORE."\">".$users_num."</a>";
			}
			echo "<tr class=\"bgcolor1\">"
			."<td align=\"center\">".c2f($grid)."</td>"
			."<td><img src=\"images/ranks/".$rank."\" border=\"0\" alt=\""._RANK."\"></td>"
			."<td class=\"help\" OnMouseOver=\"Tip('<div style=&quot;width: 500px;&quot; align=&quot;justify&quot;><b>"._DESCRIPTION.":</b> ".$description."</div>')\">".$grname."</td>"
			."<td align=\"center\">".c2f($points)."</td>"
			."<td align=\"center\">".c2f($users_num)."</td>"
			."<td align=\"center\">".$extra."</td>"
			."<td align=\"center\">".ad_edit("".$admin_file.".php?op=groups_add&id=".$grid."")." ".ad_delete("".$admin_file.".php?op=groups_del&id=".$grid."", $grname)."</td></tr>";
		}
		echo "</table>";
		close();
	} else {
		warning(""._NO_INFO."", "", "", 2);
	}
	foot();
}

function groups_add() {
	global $prefix, $db, $admin_file, $stop;
	if (isset($_REQUEST['id'])) {
		$gid = $_REQUEST['id'];
		$result = $db->sql_query("SELECT id, name, description, points, extra, rank FROM ".$prefix."_groups WHERE id='$gid'");
		list($gid, $grname, $description, $points, $extra, $rank) = $db->sql_fetchrow($result);
		$check = ($extra == "1") ? "checked" : "";
		$style = ($extra == "1") ? "none" : "inline";
	} else {
		$gid = $_POST['gid'];
		$grname = $_POST['grname'];
		$description = $_POST['description'];
		$grextra = $_POST['grextra'];
		$points = $_POST['points'];
		$rank = str_replace("images/ranks/", "", $_POST['rank']);
		$check = ($_COOKIE['gr'] == "hide") ? "checked" : "";
	}
	$rank = ($rank) ? $rank : "rank_0.png";
	head();
	groups_navi();
	if ($stop) warning($stop, "", "", 1);
	open();
	echo "<form name=\"post\" action=\"".$admin_file.".php\" method=\"post\">"
	."<script language=\"JavaScript\" type=\"text/javascript\" src=\"ajax/show_image.js\"></script>"
	."<div class=\"left\">"._GTITLE.":</div><div class=\"center\"><input type=\"text\" name=\"grname\" maxlength=\"255\" value=\"$grname\" size=\"65\" class=\"admin\"></div>"
	."<div class=\"left\">"._DESCRIPTION.":</div><div class=\"center\"><textarea name=\"description\" cols=\"65\" rows=\"5\" class=\"admin\">$description</textarea></div>"
	."<div class=\"left\">"._SPEC_GROUP.":</div><div id=\"gr".$gid."-title\" class=\"center\"><input type=\"checkbox\" name=\"grextra\" value=\"1\" ".$check."></div>"
	."<div id=\"gr".$gid."\" style=\"display: ".$style.";\"><div class=\"left\">"._POINTSNEEDED.":</div><div class=\"center\"><input type=\"text\" name=\"points\" maxlength=\"20\" value=\"$points\" size=\"65\" class=\"admin\"></div></div><script language=\"JavaScript\" type=\"text/javascript\">var admg = new SwitchCont('gr".$gid."', '');</script>"
	."<div class=\"left\">"._IMG.":</div><div class=\"center\"><select name=\"rank\" onChange=\"ShowImage('post', 'rank', '1')\" class=\"admin\">";
	$dir = opendir("images/ranks");
	while ($entry = readdir($dir)) {
		if (preg_match("/(\.gif|\.png|\.jpg|\.jpeg)$/is", $entry) && $entry != "." && $entry != "..") {
			$sel = ($rank == $entry) ? "selected" : "";
			echo "<option value=\"images/ranks/".$entry."\" $sel>".$entry."</option>";
		}
	}
	closedir($dir);
	echo "</select></div>"
	."<div class=\"left\">"._NAME.":</div><div class=\"center\"><img src=\"images/ranks/".$rank."\" name=\"pictures\" alt=\""._RANK."\"></div>"
	."<div class=\"button\"><input type=\"hidden\" name=\"gid\" value=\"$gid\"><input type=\"hidden\" name=\"op\" value=\"groups_save\"><input type=\"submit\" value=\""._SAVE."\" class=\"fbutton\"></div></form>";
	close();
	foot();
}

function groups_save() {
	global $prefix, $db, $admin_file, $stop;
	$id = intval($_POST['gid']);
	$grname = save_text($_POST['grname']);
	$description = save_text($_POST['description']);
	$points = $_POST['points'];
	$grextra = $_POST['grextra'];
	$rank = $_POST['rank'];
	if (!is_numeric($points) && $grextra != "1") $stop = ""._NONUMVALUE."";
	if (!$stop) {
		$points = ($grextra == "1") ? "0" : $points;
		$rank = str_replace("images/ranks/", "", $rank);
		if ($id) {
			$db->sql_query("UPDATE ".$prefix."_groups SET name='$grname', description='$description', points='$points', extra='$grextra', rank='$rank' WHERE id='$id'");
		} else {
			$db->sql_query("INSERT INTO ".$prefix."_groups VALUES (NULL, '$grname', '$description', '$points', '$grextra', '$rank')");
		}
		Header("Location: ".$admin_file.".php?op=groups");
	} else {
		groups_add();
	}
}

function groups_points() {
	global $prefix, $db, $admin_file, $confu;
	head();
	groups_navi();
	open();
	echo "<table width=\"100%\" border=\"0\" cellpadding=\"3\" cellspacing=\"1\" class=\"sort\" id=\"sort_id\"><tr>"
	."<form action=\"".$admin_file.".php\" method=\"post\">"
	."<th>"._ID."</th><th>"._CUSTOMTITLE."</th><th>"._DESCRIPTION."</th><th>"._POINTS."</th></tr>";
	$p = array(_POINTS01, _POINTS02, _POINTS03, _POINTS04, _POINTS05, _POINTS06, _POINTS07, _POINTS08, _POINTS09, _POINTS10, _POINTS11, _POINTS12, _POINTS13, _POINTS14, _POINTS15, _POINTS16, _POINTS17, _POINTS18, _POINTS19, _POINTS20, _POINTS21, _POINTS22, _POINTS23, _POINTS24, _POINTS25, _POINTS26, _POINTS27, _POINTS28, _POINTS29, _POINTS30, _POINTS31, _POINTS32, _POINTS33, _POINTS34, _POINTS35, _POINTS36, _POINTS37, _POINTS38, _POINTS39, _POINTS40, _POINTS41, _POINTS42, _POINTS43);
	$d = array(_DESC01, _DESC02, _DESC03, _DESC04, _DESC05, _DESC06, _DESC07, _DESC08, _DESC09, _DESC10, _DESC11, _DESC12, _DESC13, _DESC14, _DESC15, _DESC16, _DESC17, _DESC18, _DESC19, _DESC20, _DESC21, _DESC22, _DESC23, _DESC24, _DESC25, _DESC26, _DESC27, _DESC28, _DESC29, _DESC30, _DESC31, _DESC32, _DESC33, _DESC34, _DESC35, _DESC36, _DESC37, _DESC38, _DESC39, _DESC40, _DESC41, _DESC42, _DESC43);
	$points = explode(",", $confu['points']);
	for ($i = 0; $i < count($p); $i++) {
		$a = $i + 1;
		echo "<tr class=\"bgcolor1\"><td align=\"center\">".c2f($a)."</td><td>".$p[$i]."</td><td>".$d[$i]."</td><td align=\"center\"><input type=\"text\" value=\"".$points[$i]."\" name=\"spoints[]\" size=\"5\"></td></tr>";
	}
	echo "</table><br><div class=\"button\"><input type=\"hidden\" name=\"op\" value=\"groups_points_save\"><input type=\"submit\" value=\""._SAVE."\" class=\"fbutton\"></div></form>";
	close();
	foot();
}

switch($op) {
	case "groups":
	groups();
	break;
	
	case "groups_add":
	groups_add();
	break;
	
	case "groups_save":
	groups_save();
	break;
	
	case "groups_del":
	$db->sql_query("DELETE FROM ".$prefix."_groups WHERE id='".$id."'");
	$db->sql_query("UPDATE ".$prefix."_modules SET mod_group='0' WHERE mod_group='".$id."'");
	Header("Location: ".$admin_file.".php?op=groups");
	break;
	
	case "groups_points":
	groups_points();
	break;
	
	case "groups_points_save":
	$spoints = $_POST['spoints'];
	if (isset($spoints)) {
		$npoints = implode(",", $spoints);
		$content = file_get_contents("config/config_users.php");
		$content = str_replace("\$confu['points'] = \"".$confu['points']."\";", "\$confu['points'] = \"".$npoints."\";", $content);
		$fp = fopen("config/config_users.php", "wb");
		fwrite($fp, $content);
		fclose($fp);
	}
	Header("Location: ".$admin_file.".php?op=groups_points");
	break;
}
?>