<?php
/************************************************
 SLAED CMS 1.2 : Content Management System
 http://www.slaed.ir
 Developed By Mohammad Reza Mahmoudi 
 ~ mrezam2pm@gmail.com
 > Copyright (c) 2005-2010 By Slaed.ir
************************************************/

if (!defined("ADMIN_FILE") || !is_admin_god()) die("Illegal File Access");

function module() {
	global $prefix, $db, $admin_file, $infos;
	head();
	panel();
	title(""._MODULESADMIN."");
	if (isset($infos)) warning("".$infos."", "", "", 2);
	$handle = opendir("modules");
	$modlist = "";
	while ($file = readdir($handle)) {
		if (!preg_match("/\./", $file) && file_exists("modules/$file/index.php")) $modlist .= "$file ";
	}
	closedir($handle);
	$modlist = explode(" ", $modlist);
	sort($modlist);
	for ($i = 0; $i < sizeof($modlist); $i++) {
		if ($modlist[$i] != "") {
			list($mid) = $db->sql_fetchrow($db->sql_query("SELECT mid FROM ".$prefix."_modules WHERE title='$modlist[$i]'"));
			if ($mid == "") $db->sql_query("INSERT INTO ".$prefix."_modules VALUES (NULL, '$modlist[$i]', '$modlist[$i]', '0', '0', '1', '0', '0', '0')");
		}
	}
	$result = $db->sql_query("SELECT title FROM ".$prefix."_modules");
	while (list($title) = $db->sql_fetchrow($result)) {
		$a = 0;
		$handle = opendir("modules");
		while ($file = readdir($handle)) {
			if ($file == $title && file_exists("modules/$file/index.php")) $a = 1;
		}
		closedir($handle);
		if ($a == 0) $db->sql_query("DELETE FROM ".$prefix."_modules WHERE title='$title'");
	}
	open();
	echo "<table width=\"100%\" border=\"0\" cellpadding=\"3\" cellspacing=\"1\" class=\"sort\" id=\"sort_id\">"
	."<tr><th>"._MODUL."</th><th>"._CUSTOMTITLE."</th><th>"._VIEW."</th><th>"._GROUP."</th><th>"._FUNCTIONS."</th></tr>";
	$result = $db->sql_query("SELECT mid, title, custom_title, active, view, inmenu, mod_group FROM ".$prefix."_modules ORDER BY title ASC");
	while (list($mid, $title, $custom_title, $active, $view, $inmenu, $mod_group) = $db->sql_fetchrow($result)) {
		if ($custom_title == "") {
			$custom_title = str_replace("_", " ", $title);
			$db->sql_query("UPDATE ".$prefix."_modules SET custom_title='$custom_title' WHERE mid='$mid'");
		}
		$act = ($active) ? "0" : "1";
		if ($custom_title == "") $custom_title = str_replace("_", " ", $title);
		if ($view == 0) {
			$who_view = ""._MVALL."";
		} elseif ($view == 1) {
			$who_view = ""._MVUSERS."";
		} elseif ($view == 2) {
			$who_view = ""._MVADMIN."";
		}
		if ($inmenu == 0) $title = "<div class=\"help\" OnMouseOver=\"Tip('"._NO_SICHT."')\">[ $title ]</div>";
		if ($mod_group != 0) {
			$grp = $db->sql_fetchrow($db->sql_query("SELECT name FROM ".$prefix."_groups WHERE id='$mod_group'"));
			$mod_group = $grp['name'];
		} else {
			$mod_group = ""._NONE."";
		}
		if (file_exists("modules/".$title."/sql/table.sql")) {
			$filename = file_get_contents("modules/".$title."/sql/table.sql");
			$stringdump = explode(";", $filename);
			$install = "";
			for ($i = 0; $i < count($stringdump); $i++) {
				$string = str_replace("{pref}", $prefix, $stringdump[$i]);
				if (preg_match("/CREATE|ALTER|DELETE|DROP|UPDATE/i", $string)) {
					$table = explode("`", $string);
					$install .= $db->sql_fetchrow($db->sql_query("SELECT Count(*) FROM ".$table[1].""));
				}
			}
			if ($install) {
				$sqlimg = "<a href=\"".$admin_file.".php?op=module_add&mod=$title&id=1\" OnClick=\"return DelCheck(this, '"._DB_DELETE." &quot;$title&quot;?');\" title=\""._DB_DELETE."\"><img src=\"".img_find("all/d_delete")."\" border=\"0\" align=\"center\" title=\""._DB_DELETE."\"></a>";
			} else {
				$sqlimg = "<a href=\"".$admin_file.".php?op=module_add&mod=$title&id=2\" OnClick=\"return DelCheck(this, '"._DB_INSTALL." &quot;$title&quot;?');\" title=\""._DB_INSTALL."\"><img src=\"".img_find("all/d_add")."\" border=\"0\" align=\"center\" title=\""._DB_INSTALL."\"></a>";
			}
		} else {
			$sqlimg = "";
		}
		if (file_exists("modules/".$title."/sql/update.sql")) {
			$sqluimg = "<a href=\"".$admin_file.".php?op=module_add&mod=$title&id=3\" OnClick=\"return DelCheck(this, '"._DB_UPDATE." &quot;$title&quot;?');\" title=\""._DB_UPDATE."\"><img src=\"".img_find("all/d_update")."\" border=\"0\" align=\"center\" title=\""._DB_UPDATE."\"></a> ";
		} else {
			$sqluimg = "";
		}
		echo "<tr class=\"bgcolor1\"><td  align='center'>$title</td><td  align='center'>$custom_title</td><td align=\"center\">".$who_view."</td><td align=\"center\">".$mod_group."</td><td align=\"center\">".$sqlimg." ".$sqluimg."".ad_edit("".$admin_file.".php?op=module_edit&mid=".$mid."")." ".ad_status("".$admin_file.".php?op=module_status&id=".$mid."&act=".$act."", $active)."</td></tr>";
	}
	echo "</table>";
	close();
	foot();
}

function module_edit() {
	global $prefix, $db, $admin_file;
	$mid = intval($_GET['mid']);
	list($title, $custom_title, $view, $inmenu, $mod_group, $blocks_m, $blocks_m_c) = $db->sql_fetchrow($db->sql_query("SELECT title, custom_title, view, inmenu, mod_group, blocks, blocks_c FROM ".$prefix."_modules WHERE mid='$mid'"));
	head();
	panel();
	title(""._MODULEEDIT."");
	open();
	$sel1 = ($view == 0) ? "selected" : "";
	$sel2 = ($view == 1) ? "selected" : "";
	$sel3 = ($view == 2) ? "selected" : "";
	$insel1 = ($inmenu == 1) ? "checked" : "";
	$insel2 = ($inmenu == 0) ? "checked" : "";
	$bsel0 = ($blocks_m == 0) ? "selected" : "";
	$bsel1 = ($blocks_m == 1) ? "selected" : "";
	$bsel2 = ($blocks_m == 2) ? "selected" : "";
	$bsel3 = ($blocks_m == 3) ? "selected" : "";
	$bselc0 = ($blocks_m_c == 0) ? "selected" : "";
	$bselc1 = ($blocks_m_c == 1) ? "selected" : "";
	$bselc2 = ($blocks_m_c == 2) ? "selected" : "";
	$bselc3 = ($blocks_m_c == 3) ? "selected" : "";
	echo "<h2>"._CHANGEMODNAME."</h2>"
	."<form action=\"".$admin_file.".php\" method=\"post\">"
	."<div class=\"left\">"._CUSTOMMODNAME."</div><div class=\"center\"><input type=\"text\" name=\"custom_title\" value=\"$custom_title\" size=\"45\" class=\"admin\"></div>"
	."<div class=\"left\">"._VIEWPRIV."</div><div class=\"center\"><select name=\"view\" class=\"admin\">"
	."<option value=\"0\" $sel1>"._MVALL."</option>"
	."<option value=\"1\" $sel2>"._MVUSERS."</option>"
	."<option value=\"2\" $sel3>"._MVADMIN."</option>"
	."</select></div>";
	$numrow = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_groups"));
	if ($numrow > 0) {
		echo "<div class=\"left\">"._UGROUP.":</div><div class=\"center\"><select name=\"mod_group\" class=\"admin\">";
		$result2 = $db->sql_query("SELECT id, name FROM ".$prefix."_groups");
		while ($row2 = $db->sql_fetchrow($result2)) {
			if ($row2[id] == $mod_group) { $gsel = "selected"; } else { $gsel = ""; }
			if ($dummy != 1) {
				if ($mod_group == 0) { $ggsel = "selected"; } else { $ggsel = ""; }
				echo "<option value=\"0\" $ggsel>"._NONE."</option>";
				$dummy = 1;
			}
			echo "<option value=\"$row2[id]\" $gsel>$row2[name]</option>";
			$gsel = "";
		}
		echo "</select></div>";
	} else {
		echo "<input type=\"hidden\" name=\"mod_group\" value=\"0\">";
	}
	echo "<div class=\"left\">"._BLOCKS_MOD.":</div><div class=\"center\"><select name=\"blocks_m\" class=\"admin\">"
	."<option value=\"0\" $bsel0>"._BLOCKS_MOD0."</option>"
	."<option value=\"1\" $bsel1>"._BLOCKS_MOD1."</option>"
	."<option value=\"2\" $bsel2>"._BLOCKS_MOD2."</option>"
	."<option value=\"3\" $bsel3>"._BLOCKS_MOD3."</option>"
	."</select></div>"
	."<div class=\"left\">"._BLOCKS_MOD.":</div><div class=\"center\"><select name=\"blocks_m_c\" class=\"admin\">"
	."<option value=\"0\" $bselc0>"._BLOCKS_MODC0."</option>"
	."<option value=\"1\" $bselc1>"._BLOCKS_MODC1."</option>"
	."<option value=\"2\" $bselc2>"._BLOCKS_MODC2."</option>"
	."<option value=\"3\" $bselc3>"._BLOCKS_MODC3."</option>"
	."</select></div>"
	."<div class=\"left\">"._SHOWINMENU."</div><div class=\"center\"><input type=\"radio\" name=\"inmenu\" value=\"1\" $insel1> "._YES." &nbsp;&nbsp; <input type=\"radio\" name=\"inmenu\" value=\"0\" $insel2> "._NO."</div>"
	."<div class=\"button\"><input type=\"hidden\" name=\"mid\" value=\"$mid\"><input type=\"hidden\" name=\"op\" value=\"module_edit_save\"><input type=\"submit\" value=\""._SAVECHANGES."\" class=\"fbutton\"></div></form>";
	close();
	foot();
}

switch ($op) {
	case "module":
	module();
	break;
	
	case "module_status":
	$db->sql_query("UPDATE ".$prefix."_modules SET active='$act' WHERE mid='$id'");
	Header("Location: ".$admin_file.".php?op=module");
	break;
	
	case "module_edit":
	module_edit();
	break;
	
	case "module_edit_save":
	$mid = intval($_POST['mid']);
	$custom_title = $_POST['custom_title'];
	$view = $_POST['view'];
	$inmenu = $_POST['inmenu'];
	$mod_group = ($view != 1) ? 0 : $_POST['mod_group'];
	$blocks_m = $_POST['blocks_m'];
	$blocks_m_c = $_POST['blocks_m_c'];
	$result = $db->sql_query("UPDATE ".$prefix."_modules SET custom_title='$custom_title', view='$view', inmenu='$inmenu', mod_group='$mod_group', blocks='$blocks_m', blocks_c='$blocks_m_c' WHERE mid='$mid'");
	Header("Location: ".$admin_file.".php?op=module");
	break;
	
	case "module_add":
	$module = $_GET['mod'];
	$id = intval($_GET['id']);
	if ($module && $id) {
		$filename = ($id == 3) ? file_get_contents("modules/".$module."/sql/update.sql") : file_get_contents("modules/".$module."/sql/table.sql");
		if ($id == 1) {
			$ttitle = ""._DB_DELETE."";
		} elseif ($id == 2) {
			$ttitle = ""._DB_INSTALL."";
		} elseif ($id == 3) {
			$ttitle = ""._DB_UPDATE."";
		}
		$stringdump = explode(";", $filename);
		for ($i = 0; $i < count($stringdump); $i++) {
			$string = str_replace("{pref}", $prefix, $stringdump[$i]);
			if ($id != 1) $ident = $db->sql_query(stripslashes($string));
			if (preg_match("/CREATE|ALTER|DELETE|DROP|UPDATE/i", $string)) {
				$table = explode("`", $string);
				if ($id == 1) $ident = $db->sql_query("DROP TABLE ".$table[1]."");
				$info .= ""._TABLE.": ".$table[1]." - ".(($ident) ? "<font color=\"green\">"._OK."</font>" : "<font color=\"red\">"._ERROR."</font>")."</font><br>";
			}
		}
		$infos = "".$ttitle.": ".$module."<br><br>".$info."";
	}
	module();
	break;
}
?>