<?php
/************************************************
 SLAED CMS 1.2 : Content Management System
 http://www.slaed.ir
 Developed By Mohammad Reza Mahmoudi 
 ~ mrezam2pm@gmail.com
 > Copyright (c) 2005-2010 By Slaed.ir
************************************************/

if (!defined("MODULE_FILE")) {
	Header("Location: ../../index.php");
	exit;
}
get_lang($conf['name']);
include("config/config_voting.php");

function poll() {
	global $prefix, $db, $currentlang, $pagetitle, $conf, $confv;
	$querylang = ($conf['multilingual'] == 1) ? "WHERE (planguage='$currentlang' OR planguage='') AND poll_date <= now()" : "WHERE poll_date <= now()";
	$num = isset($_GET['num']) ? intval($_GET['num']) : "1";
	$offset = ($num-1) * $confv['pollnum'];
	$pagetitle = "".$conf['defis']." "._VOTING."";
	head();
	title(""._VOTING."");
	$result = $db->sql_query("SELECT poll_id, poll_date, poll_title, pool_vote, pool_comments, acomm FROM ".$prefix."_survey $querylang ORDER BY poll_id DESC LIMIT $offset, ".$confv['pollnum']."");
	if ($db->sql_numrows($result) > 0) {
		open();
		echo "<table width=\"100%\" border=\"0\" cellpadding=\"3\" cellspacing=\"2\">";
		$cn = 1;
		while (list($id, $poll_date, $poll_title, $pool_vote, $pool_comments, $acomm) = $db->sql_fetchrow($result)) {
			$p_data =format_time($poll_date ,"d.m.Y");
			$trcolor = ($cn == 2) ? "class=\"bgcolor2\"" : "";
			echo "<tr $trcolor><td>$p_data</td><td><a href=\"index.php?name=".$conf['name']."&op=view&id=".$id."\" title=\"$poll_title\"><img src=\"".img_find("all/voting")."\" border=\"0\" alt=\"$poll_title\"></a></td><td><a href=\"index.php?name=".$conf['name']."&op=view&id=".$id."\" title=\"$poll_title\">$poll_title</a></td><td>"._SVOTES." ( ".c2f($pool_vote)." )";
			if ($acomm == 0) echo " "._SCOMM." ( ".c2f($pool_comments)." )";
			echo "</td></tr>";
			$cn++;
			if ($cn == 3) $cn = 1;
		}
		echo "</table>";
		close();
		list($numstories) = $db->sql_fetchrow($db->sql_query("SELECT Count(poll_id) FROM ".$prefix."_survey $querylang"));
		$numpages = ceil($numstories / $confv['pollnum']);
		num_page($conf['name'], $numstories, $numpages, $confv['pollnum'], "");
	} else {
		warning(""._NO_INFO."", "", "", 2);
	}
	foot();
}

function view() {
	global $db, $prefix, $ThemeSel, $user, $currentlang, $pagetitle, $conf, $confv;
	$querylang = ($conf['multilingual'] == 1) ? "WHERE (planguage='$currentlang' OR planguage='')" : "";
	$id = intval($_GET['id']);
	$result = $db->sql_query("SELECT * FROM ".$prefix."_survey WHERE poll_id='$id' AND poll_date <= now()");
	if ($db->sql_numrows($result) > 0) {
		$ip = getip();
		$past = time() - intval($confv['voting_t']);
		$cookies = (intval($_COOKIE[''.substr($conf['name'], 0, 2).'-'.$id.''])) ? $_COOKIE[''.substr($conf['name'], 0, 2).'-'.$id.''] : "";
		$uid = (is_user()) ? intval(substr($user[0], 0, 11)) : 0;
		$db->sql_query("DELETE FROM ".$prefix."_rating WHERE time<'$past' AND modul='voting'");
		list($num) = $db->sql_fetchrow($db->sql_query("SELECT Count(id) FROM ".$prefix."_rating WHERE (mid='$id' AND modul='voting' AND host='$ip') OR (mid='$id' AND modul='voting' AND uid='$uid' AND uid!='0')"));
		if ($cookies == $id || $num > 0) {
			$rate = 1;
		} else {
			$rate = 0;
		}
		$row = $db->sql_fetchrow($result);
		$questions = explode("|", $row[poll_questions]);
		$p_summ = $row[pool_vote];
		$nm = 1;
		for ($i = 0; $i<count($questions)-1; $i++) {
			$a_ques[$i] = $questions[$i];
			$a_poll[$i] = $row[poll_answer_.$nm];
			$nm++;
		}
		$m_size = getimagesize("templates/$ThemeSel/images/mainbar.gif");
		$pagetitle = "".$conf['defis']." "._VOTING." ".$conf['defis']." $row[poll_title]";
		head();
		title(""._VOTING."");
		open();
		$form = (!$rate) ? "<form action=\"index.php?name=".$conf['name']."\" method=\"post\"><input type=\"hidden\" name=\"id\" value=\"$id\"><input type=\"hidden\" name=\"op\" value=\"save\">" : "";
		echo "<h2>$row[poll_title]</h2>".$form."<table border=\"0\" cellspacing=\"0\" cellpadding=\"3\" width=\"100%\">";
		for ($i = 0; $i <count($questions)-1; $i++) {
			$n = $i + 1;
			if ($p_summ > 0) {
				$proc = 100 * $a_poll[$i] / $p_summ;
				$im_w = (int)$proc - 10;
				$procent = number_format($proc, 2);
			} else {
				$im_w = 1;
				$procent = "0.00";
			}
			$form2 = (!$rate) ? "<td rowspan=\"2\"><input type=\"radio\" name=\"questions\" value=\"".$n."\"></td>" : "";
			echo "<tr>".$form2."<td colspan=\"2\">$a_ques[$i] ($a_poll[$i])</td></tr>"
			."<tr><td width=\"90%\"><img src=\"templates/$ThemeSel/images/leftbar.gif\" alt=\"".text_filter($a_ques[$i])." - ".$procent."%\" title=\"".text_filter($a_ques[$i])." - ".$procent."%\"><img src=\"templates/$ThemeSel/images/mainbar.gif\" height=\"$m_size[1]\" width=\"".$im_w."%\" alt=\"".text_filter($a_ques[$i])." - ".$procent."%\" title=\"".text_filter($a_ques[$i])." - ".$procent."%\"><img src=\"templates/$ThemeSel/images/rightbar.gif\" alt=\"".text_filter($a_ques[$i])." - ".$procent."%\" title=\"".text_filter($a_ques[$i])." - ".$procent."%\"></td><td>".$procent."%</td></tr><tr><td height=\"5\"></td></tr>";
		}
		$form3 = (!$rate) ? "<tr><td colspan=\"3\" align=\"center\"><input type=\"submit\" value=\""._VOTE."\" class=\"fbutton\"></td></tr></form>" : "";
		echo "".$form3."</table><center>"._TOTALVOTES.": $p_summ";
		list($num) = $db->sql_fetchrow($db->sql_query("SELECT Count(poll_id) FROM ".$prefix."_survey $querylang"));
		if ($num > 1) echo "<br /><br />[ <a href=\"index.php?name=".$conf['name']."\" title=\""._MOREPOLLS."\">"._MOREPOLLS."</a> ]";
		echo "</center>";
		close();
		if ($row['acomm'] == 0) show_com($id);
		foot();
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

function save() {
	global $db, $prefix, $user, $conf, $confv;
	$id = intval($_POST['id']);
	$questions = intval($_POST['questions']);
	if ($id) {
		head();
		title(""._VOTING."");
		if (!$questions) {
			warning(""._SEROR1."", "?name=".$conf['name']."&op=view&id=$id", 3, 1);
		} else {
			$ip = getip();
			$past = time() - intval($confv['voting_t']);
			$cookies = (intval($_COOKIE[''.substr($conf['name'], 0, 2).'-'.$id.''])) ? $_COOKIE[''.substr($conf['name'], 0, 2).'-'.$id.''] : "";
			$uid = (is_user()) ? intval(substr($user[0], 0, 11)) : 0;
			$db->sql_query("DELETE FROM ".$prefix."_rating WHERE time<'$past' AND modul='voting'");
			list($num) = $db->sql_fetchrow($db->sql_query("SELECT Count(id) FROM ".$prefix."_rating WHERE (mid='$id' AND modul='voting' AND host='$ip') OR (mid='$id' AND modul='voting' AND uid='$uid' AND uid!='0')"));
			if ($cookies == $id || $num > 0) {
				warning(""._SEROR2."", "?name=".$conf['name']."&op=view&id=$id", 3, 1);
			} else {
				setcookie("".substr($conf['name'], 0, 2)."-".$id."", $id, time() + intval($confv['voting_t']));
				$new = time();
				$db->sql_query("INSERT INTO ".$prefix."_rating VALUES (NULL, '$id', '".$conf['name']."', '$new', '$uid', '$ip')");
				$db->sql_query("UPDATE ".$prefix."_survey SET poll_answer_".$questions."=poll_answer_".$questions."+1, pool_vote=pool_vote+1 WHERE poll_id='$id'");
				update_points(42);
				Header("Location: index.php?name=".$conf['name']."&op=view&id=$id");
			}
		}
		foot();
	} else {
		Header("Location: index.php?name=".$conf['name']."");
	}
}

switch($op) {
	default:
	poll();
	break;
	
	case"view":
	view();
	break;
	
	case"save":
	save();
	break;
	
	case "save_com":
	save_com();
	break;
}
?>